from django.db import models

# Create your models here.

class Kategoria(models.Model):
	nimi = models.CharField(max_length=250)
	otsikko = models.CharField(max_length=250)
	kuvaus = models.CharField(max_length=500)
	yritys = models.CharField(max_length=250, null=True)
	kansikuva_sijainti = models.CharField(max_length=250, null=True)
	alkuaika = models.DateField(null=True)
	loppuaika = models.DateField(null=True)

	def __unicode__(self):
		return self.nimi

class Kuva(models.Model):
	nimi = models.CharField(max_length=250)
	kategoria = models.ForeignKey(Kategoria)
	sijainti = models.CharField(max_length=250)

	def __unicode__(self):
		return self.nimi

class KuvaPari(models.Model):
	kuva1 = models.ForeignKey(Kuva, related_name='kuvapari_kuva1')
	kuva2 = models.ForeignKey(Kuva, related_name='kuvapari_kuva2')
	kuva1_aanet = models.IntegerField(default=0)
	kuva2_aanet = models.IntegerField(default=0)
	kategoria = models.ForeignKey(Kategoria)

	def __unicode__(self):
		return "%d_%d" % (self.kuva1, self.kuva2)

class LadattuKuva(models.Model):
	tiedosto = models.FileField(upload_to='img')