var bigBoxHeight = 0; //will get updated

function addTabsToBigBox(bigBox) {

	//Add tabs
	var tabDiv = $("<div/>").addClass("bigBoxTabDiv");
	var rateTab = $("<div/>").addClass("bigBoxTabButton").text("Rate");
	var resultsTab = $("<div/>").addClass("bigBoxTabButton").text("Results");

	if (bigBox.data("selectedTab") == 1)
		resultsTab.addClass("selectedTab");
	else
		rateTab.addClass("selectedTab");


	tabDiv.append(rateTab);
	tabDiv.append(resultsTab);

	bigBox.append(tabDiv);

	rateTab.click(function(){
		$(".bigBox").data("selectedTab", 0);
		addRatingContentToBigBox();
	});
	resultsTab.click(function() {
		$(".bigBox").data("selectedTab", 1);
		addResultsContentToBigBox();
	});
}

var ratingDataCache = null;
function addRatingContentToBigBox(data) {

	var sendRatingToServer = function(winnerID, loserID) {
		var message = winnerID + "_" + loserID;
		
		$.get("../send_rating/" + message + "/");
	}

	if (data)
		ratingDataCache = data;
	if (!ratingDataCache)
		return;

	var bigBox = $(".bigBox");

	if (bigBox.size() > 1) {
		if (bigBox.eq(0).hasClass("hidingBigBox"))
			bigBox = bigBox.eq(1);
		else
			bigBox = bigBox.eq(0);
	}

	//Clear previous big box.
	bigBox.empty();

	bigBox.data("selectedTab", 0);

	addTabsToBigBox(bigBox);
	
	var paths = ratingDataCache.split('  ');
	
	//Add top texts
	var headerDiv = $("<div/>").addClass("bigBoxHeader");
	headerDiv.text(paths[7]);
	bigBox.append(headerDiv);

	var descriptionDiv = $("<div/>").addClass("bigBoxDescription");
	descriptionDiv.text(paths[8]);
	bigBox.append(descriptionDiv);
	
	//Add images
	var imageDiv = $("<div/>").addClass("bigBoxImageDiv");
	bigBox.append(imageDiv);

	var img1 = $('<img src="../static/' + paths[0] + '" class="left_img"/>');
	var id1 = paths[1];
	var name1 = paths[2];
	var img2 = $('<img src="../static/' + paths[3] + '" class="right_img"/>');
	var id2 = paths[4];
	var name2 = paths[5];

	var a = $(".bigBoxImageDiv");
	var imageHeight = $(".bigBoxImageDiv").height();
	//var imageHeight = bigBoxHeight - 130;
	
	img1.click(function(){
		img1.off("click");
		img2.off("click");

		sendRatingToServer(id1, id2, ratingDataCache);

		img1.animate({opacity: 0.7}, 80);
		img1.animate({opacity: 1.0}, 80);
		img1.animate({opacity: 0.7}, 80);
		img1.animate({opacity: 1.0}, function() {
			img1.fadeOut(200, function() {
				loadRating();
			});
			img2.fadeOut();
		});
		//img2.animate({opacity: 0.4}, 100);
	});
	img2.click(function(){
		img1.off("click");
		img2.off("click");

		sendRatingToServer(id2, id1, ratingDataCache);

		img2.animate({opacity: 0.7}, 80);
		img2.animate({opacity: 1.0}, 80);
		img2.animate({opacity: 0.7}, 80);
		img2.animate({opacity: 1.0}, function() {
			img2.fadeOut(200, function() {
				loadRating();
			});
			img1.fadeOut();
		});
		//img1.animate({opacity: 0.4}, 100);
	});
	
	img1.css({"max-width": bigBox.width()/2 -5, "max-height": imageHeight});
	img2.css({"max-width": bigBox.width()/2 -5, "max-height": imageHeight});

	imageDiv.append(img1);
	imageDiv.append(img2);

	//Names

	var leftName = $("<div/>").addClass("bigBoxImageNameLeft").text(name1);
	bigBox.append(leftName);

	var rightName = $("<div/>").addClass("bigBoxImageNameRight").text(name2);
	bigBox.append(rightName);

	//Which one is better?
	var selectDiv = $("<div/>").addClass("bigBoxSelect");
	selectDiv.text("Which one is better?");
	bigBox.append(selectDiv);

/*
	var descriptionDiv = $("<div/>").addClass("bigBoxInfo");
	descriptionDiv.text("View the results of this poll by clicking on the tab on the top of this window.");
	bigBox.append(descriptionDiv);
*/
}

function addResultsContentToBigBox() {

	var createBar = function(percentage) {
		var text = $("<span/>").addClass("resultBarText").text("" + percentage + "%");
		var bar = $("<div/>").addClass("resultBar");
		var score = $("<div/>").addClass("resultBarScore").width(""+percentage+"%");
		bar.append(score);

		bar.append(text);

		return bar;
	}

	var bigBox = $(".bigBox");


	//Clear previous big box.
	bigBox.empty();

	addTabsToBigBox(bigBox);

	$.get("create_statistics_string/"+kategoria_id_cache+"/", function(data) {

		var compareText = $("<span/>").addClass("compareText").text("Check out individual face-off statistics!");
		
		var compareDesc = $("<div/>").addClass("compareDesc").html("Pics:<br/>Wins:");

		//Compare two images
		var compareDiv = $("<div/>").addClass("compareDiv");

		var menu1 = $("<select/>").addClass("selectToCompare");
		var menu2 = $("<select/>").addClass("selectToCompare");

		var result1 = $("<span/>").attr("id", "compare1").text("-");
		var result2 = $("<span/>").attr("id", "compare2").text("-");


		var valuesPerRow = 5;
		var dataArray = data.split('  ');
		
		var rows = Math.floor(dataArray.length/valuesPerRow);
		var counter = 0;

		var container = $("<div/>").addClass("resultContainer");

		var colorCode = "Odd";

		for (var i = 0; i < rows; i++) {
			
			var div = $("<div/>").addClass("resultRow resultRow" + colorCode);

			var id = parseInt(dataArray[counter++]);
			var wins = parseInt(dataArray[counter++]);
			var loses = parseInt(dataArray[counter++]);
			var url = dataArray[counter++];
			var name = dataArray[counter++];

			var img = $("<img/>").attr("src", "static/" + url).height("100%");

			div.append(img);


			var percentage = 0;
			if (wins+loses > 0)
				percentage = Math.round(100.0*wins/(wins+loses));


			var bar = createBar(percentage);
			var nameText = $("<div/>").addClass("resultRowName").text(name);
			bar.append(nameText);

			var wonDiv = $("<div/>").addClass("resultWonDiv");
			wonDiv.html("Won:<br/>" + wins);
			bar.append(wonDiv);

			var lostDiv = $("<div/>").addClass("resultLostDiv");
			lostDiv.html("Lost:<br/>" + loses);
			bar.append(lostDiv);

			div.append(bar);

			container.append(div);

			if (colorCode == "Odd")
				colorCode = "Even";
			else
				colorCode = "Odd";

			menu1.append($("<option/>").text(name).attr("imageId", id));
			menu2.append($("<option/>").text(name).attr("imageId", id));
		}

		bigBox.append(container);


		var menuChanged = function() {
			var first = menu1.find(":selected").attr("imageId");
			var second = menu2.find(":selected").attr("imageId");

			if (first == second) {
				result1.text("-");
				result2.text("-");
				return;
			}

			$.get("get_votes_for_images/"+first+"/"+second+"/", function (data) {
				var wins = data.split(" ");
				result1.text(wins[0]);
				result2.text(wins[1]);
			});
		};
		
		menu1.change(menuChanged);
		menu2.change(menuChanged);

		compareDiv.append(compareDesc);
		compareDiv.append(menu1);
		compareDiv.append($("<span/>").text(" vs. "));
		compareDiv.append(menu2);
		compareDiv.append($("<br/>"));
		compareDiv.append(result1);
		compareDiv.append(result2);

		bigBox.append(compareText);
		bigBox.append(compareDiv);

/*
		var descriptionDiv = $("<div/>").addClass("bigBoxInfo");
		descriptionDiv.text("Rate this poll by clicking on the tab on the top of this window.");
		bigBox.append(descriptionDiv);
*/
	});
}

var kategoria_id_cache = 0;
function loadRating() {
	$.get("../get_images/" + kategoria_id_cache + "/", function(data) {
		addRatingContentToBigBox(data);
	});
}


function selectBox(box, kategoria_id) {

	kategoria_id_cache = kategoria_id;

	//Remove old selection
	var selectedBox = $(".selectedBox");
	var createNewBigBox = selectedBox.size() == 0 || selectedBox.position().top != box.position().top;
	unselectBoxes(createNewBigBox);

	box.addClass("selectedBox");
	
	//Create or find big box
	if (createNewBigBox)
	{
		var lastBoxInRow = box;
		var test = lastBoxInRow.next();
		var size = test.size();
		while (lastBoxInRow.next().size() > 0 && 
			lastBoxInRow.next().position().left > lastBoxInRow.position().left) {
			lastBoxInRow = lastBoxInRow.next();
		}

		var bigBox = $("<div/>").addClass("box bigBox");

		if (createNewBigBox)
		{
			bigBox.css("display", "none");
		}

		lastBoxInRow.after(bigBox);
	}
	else
	{
		bigBox = $(".bigBox");
		//bigBox.empty();
	}

	bigBox.data("selectedTab", 0);

	var bigBoxOuterHeight = bigBox.outerHeight();
	bigBoxHeight = bigBox.height();

	//Add content to big box
	loadRating();


	//Make box visible so that we can calculate it's offset
	if (createNewBigBox)
	{
		bigBox.height(1);
		bigBox.css("display", "inline");
	}


	//Animate scrolling
	var bigBoxBottom = bigBox.offset().top + bigBoxOuterHeight;
	var selectedTop = $(".selectedBox").offset().top;
	var windowHeight = $(window).height();
	var disappearingHeight = 0;
	if (createNewBigBox && $(".bigBox").size() == 2 && !$(".bigBox:first").is(bigBox))
		disappearingHeight = $(".bigBox:first").outerHeight() + 20; //margin added

	var targetScroll = (bigBoxBottom + selectedTop)*0.5 - windowHeight*0.5 - disappearingHeight;

	$('html, body').animate({
    	scrollTop: targetScroll
 	}, "normal");


	//console.log("" + bigBox.offset().top + "," + bigBoxOuterHeight + "," + selectedTop + "," + windowHeight + "," + disappearingHeight + " = " + targetScroll);

	//start slide effect
 	if (createNewBigBox)
	{
		bigBox.animate({"height": bigBoxHeight}, "fast");
	}
}

function unselectBoxes(hideBigBox) {
	if (hideBigBox)
	{
		$(".bigBox").addClass("hidingBigBox");
		$(".bigBox").animate({"height": 0, "margin-top": 0, "margin-bottom": 0}, "fast", function(){
			$(this).remove();
		});
	}
	//else $(".bigBox").remove();

	$(".selectedBox").removeClass("selectedBox");
}

$(window).keydown(function(e){
	if (e.keyCode == 27) //esc
		unselectBoxes(true);
});


//Following code taken from:
//http://stackoverflow.com/questions/2834667/how-can-i-differentiate-a-manual-scroll-via-mousewheel-scrollbar-from-a-javasc
$('body,html').bind('scroll mousedown wheel DOMMouseScroll mousewheel keyup', function(e){
 if ( e.which > 0 || e.type == "mousedown" || e.type == "mousewheel"){
  $("html,body").stop();
 }
})

$.ajaxSetup({
    // Disable caching of AJAX responses
    cache: false
});